package org.softme.webpm.jwiki;
import org.softme.webpm.pub.*;
import org.softme.webpm.utility.*;
import java.sql.*;
import java.util.Iterator;
import java.util.ArrayList;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleFactoryImp extends ArticleFactory {

    public Article newArticle(){
        return new ArticleImp();
    }

    public Article getArticle(String pTopic) throws ArticleNotFoundException{
        pTopic=StringUtility.encodeToMysql(pTopic);
        String GET_ONE_ARTICLE="SELECT * FROM t_wiki_article WHERE ftopic='"+pTopic+"'";
        return this.getArticleFromDB(GET_ONE_ARTICLE) ;
    }
    public Article getArticle(int pID) throws ArticleNotFoundException{
        String GET_ONE_ARTICLE="SELECT * FROM t_wiki_article WHERE fid="+pID;
        return this.getArticleFromDB(GET_ONE_ARTICLE) ;
    }
    public Article getBackup(int pID) throws ArticleNotFoundException{
        String GET_ONE_BACKUP="SELECT * FROM t_wiki_articlebackup WHERE fid="+pID;
        return this.getArticleFromDB(GET_ONE_BACKUP) ;
    }
    public Article createArticle(String pTopic, String pBody, String pAuthor)throws  ArticleAlreadyExistsException {
        KeyIndex keyIndex=KeyIndex.getInstance() ;
        keyIndex.addKey(StringUtility.URLParamEncode(pTopic)) ;
        try{
            getArticle(pTopic);
            throw new ArticleAlreadyExistsException();
        }catch(ArticleNotFoundException e){
            return new ArticleImp(pTopic,pBody,pAuthor);
        }

    }
    public Iterator getRecentChanges(){
        String GET_RECENT="select *  from t_wiki_article  WHERE TO_DAYS(NOW()) - TO_DAYS(fcreatedate) <=10 order by fcreatedate desc";
        Connection conn=null;
        PreparedStatement pstmt=null;
        Article recentAr=null;
        ArrayList recentList=new ArrayList();
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(GET_RECENT) ;
            ResultSet arRs=pstmt.executeQuery() ;
            while(arRs.next()){
                recentAr=this.loadArticleFromResultSet(arRs) ;
                recentList.add(recentAr) ;
            }
        }catch(SQLException e){
            Debug.println(e.toString()) ;
            e.printStackTrace() ;
        }finally{
            DBConnection.closeConnection(pstmt,conn) ;
        }
        return recentList.iterator() ;
    }

    public Query createQuery(String pKey) {
        return new QueryImp(pKey);
    }

    public Iterator getVersions(String pTopic){
      String GET_ALL_BACKUP="SELECT * FROM t_wiki_articlebackup WHERE ftopic=? order by fid desc";
      Connection conn=null;
      PreparedStatement pstmt=null;
      Article backupA=null;
      ArrayList backupList=new ArrayList();
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_ALL_BACKUP) ;
          //вѯʱȽб
          pTopic=StringUtility.encodeToMysql(pTopic) ;
          pstmt.setString(1,pTopic) ;
          ResultSet arRs=pstmt.executeQuery() ;
          while(arRs.next()){
              backupA=this.loadArticleFromResultSet(arRs) ;
              backupList.add(backupA) ;
          }
      }catch(SQLException e){
          e.printStackTrace();
          Debug.println(e.toString()) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }
      return backupList.iterator() ;
     }

    public Article revert(int pBackupID) {
        Article backup=null,ar=null;
        try{
            backup=getBackup(pBackupID);
            ar=getArticle(backup.getTopic());
            ar.setBody(backup.getBody()) ;
            ar.setAuthor(backup.getAuthor()) ;
            ar.setCreateDate(backup.getCreateDate());
            ar.setFlag(backup.getFlag()) ;
            ar.setMender(backup.getMender()) ;
            //ar.modifyBody() ;//¸»Զһ
            ar.updateAllInfo() ;


        }catch(Exception e){

            e.printStackTrace() ;
        }
        return backup;
    }
    private Article getArticleFromDB(String pSQL) throws ArticleNotFoundException{
        Connection conn=null;
        PreparedStatement pstmt=null;
        Article existingAr=null;
        try{

            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(pSQL) ;



            ResultSet arRs=pstmt.executeQuery() ;
            if(arRs.next()){
                existingAr=this.loadArticleFromResultSet(arRs) ;
            }else{
                throw new ArticleNotFoundException("ArticleFactoryError: article not found..");
            }
        }catch(SQLException e){
            Debug.println(e.toString()) ;
            e.printStackTrace() ;
            return null;
        }finally{
            DBConnection.closeConnection(pstmt,conn) ;
        }
        return existingAr;
    }
    private Article loadArticleFromResultSet(ResultSet pRs) throws SQLException{
        Article existingAr=newArticle();
        if(pRs==null) return null;
        existingAr.setID(pRs.getInt("fid")) ;
        existingAr.setTopic(pRs.getString("ftopic")) ;
        existingAr.setBody(pRs.getString("fbody")) ;
        existingAr.setCreateDate(pRs.getString("fcreatedate")) ;
        existingAr.setFlag(pRs.getInt("fflag")) ;
        existingAr.setMender(pRs.getString("fmender")) ;
        existingAr.setAuthor(pRs.getString("fauthor")) ;
        return existingAr;
    }

}