package org.softme.webpm.jwiki;
import java.util.Iterator;
import junit.framework.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleFactoryImpTest extends TestCase{
  private  ArticleFactory arFactory=ArticleFactory.getInstance();
  private String gTopic="testtopic",gBody="testbody",gAuthor="testauthor";
  public ArticleFactoryImpTest(String name) {
    super(name);
  }
  public static Test suite(){
        return new TestSuite(ArticleFactoryImpTest.class);
  }
  public static void main(String[] args) {

        junit.textui.TestRunner.run(suite()) ;

  }
  public void testCreate(){

      try{
          Article newArticle=arFactory.createArticle(gTopic,gBody,gAuthor);
          assertEquals(newArticle.getTopic(),gTopic);
          assertEquals(newArticle.getBody(),gBody);
          assertEquals(newArticle.getAuthor(),gAuthor);
          assertEquals(newArticle.getMender(),gAuthor);//ʱĬ޸Ϊ
      }catch(ArticleAlreadyExistsException e){
          assert(true);//ڣͨ
      }
  }
  public void testGetArticle(){
      try{
          Article existingAr=arFactory.getArticle(gTopic);
          assertEquals(existingAr.getTopic(),gTopic);
          assertEquals(existingAr.getBody(),gBody);
          assertEquals(existingAr.getAuthor(),gAuthor);
        }catch(ArticleNotFoundException e){
          assert(false);
        }

  }
  public void testRecentChanges(){
      Iterator articleIterator=arFactory.getRecentChanges();
      Article recentAr=null;
      while(articleIterator.hasNext()){
          recentAr=(Article)articleIterator.next() ;
          assert(recentAr.getTopic()!=null);
          assert(recentAr.getBody()!=null);
      }
  }

  public void testRevert(){
        try{
          int mBackupTopicID=1;
          Article backupAr=arFactory.revert(mBackupTopicID) ;
          Article existingAr=arFactory.getArticle(backupAr.getTopic());

          assertEquals(backupAr.getTopic(),existingAr.getTopic());
          assertEquals(backupAr.getBody(),existingAr.getBody());
          assertEquals(backupAr.getAuthor(),existingAr.getAuthor());
          assertEquals(backupAr.getMender(),existingAr.getMender());
          //assertEquals(backupAr.getCreateDate(),existingAr.getCreateDate());
         // assertEquals(backupAr.getMender(),existingAr.getMender());

        }catch(Exception e){
            e.printStackTrace() ;
            assert(false);
        }
  }

  public void testQuery(){
      String queryString="test";
      boolean isSuccess=false;
      Query query=arFactory.createQuery("test");
      Iterator topicResult=query.searchTopic();
      Iterator bodyResult=query.searchBody();
      Article queryAr=null;
      while(topicResult.hasNext()){
          queryAr=(Article)topicResult.next() ;
          if(queryAr.getTopic().equals(gTopic)){
              isSuccess=true;
          }
      }
      assert(isSuccess);
      isSuccess=false;
      while(bodyResult.hasNext()){
          queryAr=(Article)bodyResult.next() ;
          if(queryAr.getTopic().equals(gTopic)){
              isSuccess=true;
          }
      }
      assert(isSuccess);
  }

}