package org.softme.webpm.jwiki;
import org.softme.webpm.pub.Debug;
import java.lang.reflect.*;
import org.softme.webpm.pub.WebPmConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public abstract class TagProcessorFactory {
    private static TagProcessorFactory tagFactory;
    private static String className="org.softme.webpm.jwiki.TagProcessorFactoryImp";
    private static Object initLock = new Object();
    /**
     * ֻ֤һʵ
     */
    public static TagProcessorFactory getInstance(){
        if (tagFactory == null) {
            synchronized(initLock) {
                if (tagFactory == null) {
                    try {
                        String classNameProp=WebPmConfig.getProperty("TagProcessorFactoryImp.className") ;
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);

                        tagFactory = (TagProcessorFactory)c.newInstance();
                        //try {
                           // Method m = c.getMethod("getTagProcessorFactoryInstance", null);
                            //tagFactory=(TagProcessorFactory)m.invoke(tagFactory,null);
                        //}
                        //catch (NoSuchMethodException nsme) {System.out.print(nsme.toString()) ; }
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load TagProcessorFactory class "
                            + className + ". Jwiki cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return tagFactory;

    }

    public abstract String processTags(String pBody);

    public abstract TagProcessor getProcessor(String pProcessorName);


}