package org.softme.webpm.pub ;
import org.softme.webpm.utility.XMLUtility;
import java.io.*;
import java.util.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WebPmConfig {

    static private WebPmConfig configInstance=null;
    static private HashMap properties=new HashMap();
    static public String SEPARATOR=(System.getProperties()).getProperty("file.separator");

    private WebPmConfig() {

    }
    public static String getProperty(String pParam){
        if(configInstance==null){
            configInstance=new WebPmConfig();
            Debug.println("Config properties....") ;
            configInstance.loadFilePath() ;
            configInstance.loadProperties();
        }
        String value=(String)properties.get(pParam) ;
        return value;

    }


    private static void loadProperties(){


        //Debug.println(WebPmConfig.getProperty("Path.configfile")+"##########");
        ///usr/tomcat/tomcat/webapps/webpm/conf/config.xml

        Document doc=XMLUtility.xml2Document(WebPmConfig.getProperty("Path.configfile")) ;
        Element rootElement=doc.getDocumentElement() ;
        Element jwikiElement=(Element)(rootElement.getElementsByTagName("Jwiki").item(0)) ;
        loadChineseCode(rootElement);
        loadDBConfig(rootElement);
        loadWikiConfig(jwikiElement);
        Debug.print("\n") ;
    }

    private static void loadFilePath(){
       properties.put("WebPM.Home","E:\\tomcat4\\webapps\\webpm") ;///usr/tomcat/tomcat/webapps/webpm

       String tagFile=WebPmConfig.getProperty("WebPM.Home")+WebPmConfig.SEPARATOR+"conf"+WebPmConfig.SEPARATOR+"tag.xml";
       String configFile=WebPmConfig.getProperty("WebPM.Home")+WebPmConfig.SEPARATOR+"conf"+WebPmConfig.SEPARATOR+"config.xml";


       properties.put("Path.tagfile",tagFile) ;
       properties.put("Path.configfile",configFile) ;

       Debug.println("tag file path: "+tagFile) ;
       Debug.println("config file path: "+configFile) ;
    }

    private static void loadWikiConfig(Element rootElement){
        String articleFactoryClassName=XMLUtility.getNodeAttr(rootElement,"ArticleFactoryImp","className") ;
        String tagProcessorFactoryClassName=XMLUtility.getNodeAttr(rootElement,"TagProcessorFactoryImp","className") ;
        properties.put("ArticleFactoryImp.className",articleFactoryClassName) ;
        properties.put("TagProcessorFactoryImp.className",tagProcessorFactoryClassName) ;

        Debug.println("ArticleFactoryImp.className: "+articleFactoryClassName) ;
        Debug.println("TagProcessorFactoryImp.className: "+tagProcessorFactoryClassName) ;
    }
    private static void loadChineseCode(Element rootElement){
        String StringCode=XMLUtility.getNodeAttr(rootElement,"StringChineseCode","Code");
        String StringGetBytesCode=XMLUtility.getNodeAttr(rootElement,"StringChineseCode","GetBytes");
        String DBCode=XMLUtility.getNodeAttr(rootElement,"DBChineseCode","Code");
        String DBGetBytesCode=XMLUtility.getNodeAttr(rootElement,"DBChineseCode","GetBytes");

        properties.put("Encoder.StringCode",StringCode);
        properties.put("Encoder.StringGetBytes" ,StringGetBytesCode);
        properties.put("Encoder.DBCode" ,DBCode);
        properties.put("Encoder.DBGetBytes" ,DBGetBytesCode);

        Debug.println("Chinese Encode:StringCode is:"+StringCode+"    GetBytes is:"+StringGetBytesCode) ;

        Debug.println("DB Encode:StringCode is:"+DBCode+"    GetBytes is:"+DBGetBytesCode) ;
    }
    private static void loadDBConfig(Element rootElement){
        String DBUserName=XMLUtility.getNodeAttr(rootElement,"DBConfig","UserName");
        String DBURL=XMLUtility.getNodeAttr(rootElement,"DBConfig","URL");
        String DBPassword=XMLUtility.getNodeAttr(rootElement,"DBConfig","Password");
        String DBDriver=XMLUtility.getNodeAttr(rootElement,"DBConfig","Driver");

        properties.put("DB.UserName" ,DBUserName);
        properties.put("DB.URL" ,DBURL);
        properties.put("DB.Password" ,DBPassword);
        properties.put("DB.Driver" ,DBDriver) ;

        Debug.println("DB Driver :"+DBDriver);
        Debug.println("DB URL:"+DBURL);


    }


}