package org.softme.webpm.wiki;
import org.softme.webpm.utility.*;
import org.softme.webpm.pub.*;
import java.sql.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class Article {
  private String sTopic,sBody,sAuthor,sCreateDate;
  private boolean isLock=false;

  public String getTopic(){
      return sTopic;
  }
  public String getBody(){
      return sBody;
  }
  public String getAuthor(){
      return sAuthor;
  }
  public String getCreateDate(){
      return sCreateDate;
  }
  public boolean isLock(){
      return isLock;
  }
  public void setBody(String pBody){
      this.sBody =pBody;
  }
  public void setTopic(String pTopic){
      this.sTopic =pTopic;
  }
  public void setAuthor(String pAuthor){
      this.sAuthor =pAuthor;
  }
  public void setLock(boolean pLock){
      this.isLock =pLock;
  }
  public void setCreateDate(String pDate){
      this.sCreateDate =pDate;
  }
  public Article(){
  }
  public Article(String pTopic,String pBody,String pAuthor,String pCreateDate,boolean pLock){
      this.sTopic =pTopic;
      this.sAuthor =pAuthor;
      this.sCreateDate =pCreateDate;
      this.sBody =pBody;
      this.isLock =pLock;
  }
  public Article(String pTopic,String pBody,String pAuthor) {
      this.sTopic =pTopic;
      this.sBody =pBody;
      this.sAuthor =pAuthor;
      this.sCreateDate =DateTimeUtility.getCurrentDateTime() ;
      this.isLock =false;
      insertToDB();
  }
  public Article updateBody(){
      updateBodyToDB();
      return this;
  }
  private void insertToDB(){
      String INSERT_ARTICLE="INSERT INTO article values (?,?,?,?,?) ";
      PreparedStatement pstmt=null;
      Connection conn=null;
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(INSERT_ARTICLE) ;
          pstmt.setString(1,sTopic) ;
          pstmt.setString(2,sBody);
          pstmt.setString(3,sAuthor) ;
          pstmt.setString(4,sCreateDate) ;
          pstmt.setBoolean(5,isLock) ;
          pstmt.executeUpdate() ;


          //ݲ,conn Ϊ֧
          insertBackup(conn);
      }catch(SQLException e){
          Debug.println(e.toString()) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn);
      }
  }
  private void insertBackup(Connection conn){
      String INSERT_ARTICLE_BACKUP="INSERT INTO articlebackup(topic,body,author,createdate,islock) values (?,?,?,?,?)";
      PreparedStatement pstmt=null;
      try{
          pstmt=conn.prepareStatement(INSERT_ARTICLE_BACKUP) ;
          pstmt.setString(1,sTopic) ;
          pstmt.setString(2,sBody);
          pstmt.setString(3,sAuthor) ;
          pstmt.setString(4,sCreateDate) ;
          pstmt.setBoolean(5,isLock) ;
          pstmt.executeUpdate() ;
      }catch(SQLException e){
          e.printStackTrace() ;
      }finally{
          try{
              pstmt.close() ;
          }catch(SQLException e){
              e.printStackTrace() ;
          }
      }
  }
  private void updateBodyToDB(){
      String UPDATE_ARTICLE="UPDATE article SET body=?,createdate=? WHERE topic=?";
      sCreateDate=DateTimeUtility.getCurrentDateTime();
      PreparedStatement pstmt=null;
      Connection conn=null;
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
          pstmt.setString(1,sBody) ;
          pstmt.setString(2,sCreateDate) ;
          pstmt.setString(3,sTopic) ;
          pstmt.executeUpdate() ;
          insertBackup(conn);
      }catch(SQLException e){
          Debug.println(e.toString() ) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn);
      }
  }



}