package org.softme.webpm.wiki;
import java.sql.*;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.Debug;
import java.util.Iterator;
import java.util.Vector;
import org.softme.webpm.utility.StringUtility;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleBackup {
  private int iID;
  private String sTopic;
  private String sBody;
  private String sAuthor;
  private String sCreateDate;
  private boolean bLock;

  public ArticleBackup(){
  }

  public ArticleBackup(int pID,String pTopic,String pBody,String pAuthor,String pCreateDate,boolean pLock) {
      this.iID =pID;
      this.sBody =pBody;
      this.sAuthor =pAuthor;
      this.sCreateDate =pCreateDate;
      this.bLock =pLock;
  }

  public int getID(){
      return iID;
  }
  public String getTopic(){
      return sTopic;
  }
  public String getBody(){
      return sBody;
  }
  public String getAuthor(){
      return sAuthor;
  }
  public String getCreateDate(){
      return sCreateDate;
  }
  public boolean isLock(){
      return bLock;
  }
  public Iterator getRecentChange(){
      String GET_RECENT="select *  from webpm.article  WHERE TO_DAYS(NOW()) - TO_DAYS(createdate) <=10 order by createdate desc";
      Connection conn=null;
      PreparedStatement pstmt=null;
      Article RecentA=null;
      Vector RecentList=new Vector();
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_RECENT) ;
          //вѯʱȽб
          ResultSet arRs=pstmt.executeQuery() ;
          while(arRs.next()){
              RecentA=new Article(arRs.getString("topic"),
                                arRs.getString("body"),
                                arRs.getString("author"),
                                arRs.getString("createdate"),
                                arRs.getBoolean("islock")
                                );
              RecentList.addElement(RecentA) ;
          }
      }catch(SQLException e){
          Debug.println(e.toString()) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }
      return RecentList.iterator() ;
  }
  public Iterator getVersions(String pTopic){
      String GET_ALL_BACKUP="SELECT * FROM webpm.articlebackup WHERE topic=? order by id desc";
      Connection conn=null;
      PreparedStatement pstmt=null;
      ArticleBackup backupA=null;
      Vector backupList=new Vector();
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_ALL_BACKUP) ;
          //вѯʱȽб
          pTopic=StringUtility.encodeToMysql(pTopic) ;
          pstmt.setString(1,pTopic) ;
          ResultSet arRs=pstmt.executeQuery() ;
          while(arRs.next()){
              backupA=new ArticleBackup(arRs.getInt("id"),
                                arRs.getString("topic"),
                                arRs.getString("body"),
                                arRs.getString("author"),
                                arRs.getString("createdate"),
                                arRs.getBoolean("islock")
                                );
              backupList.addElement(backupA) ;
          }
      }catch(SQLException e){
          Debug.println(e.toString()) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }
      return backupList.iterator() ;
  }
  public ArticleBackup(int pID) throws ArticleNotFoundException{
      Connection conn=null;
      PreparedStatement pstmt=null;
      try{
          String GET_ONE_BACKUP="SELECT * FROM webpm.articlebackup WHERE id=?";
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_ONE_BACKUP) ;
          //вѯʱȽб
          //pTopic=StringUtility.encodeToMysql(pTopic) ;
          pstmt.setInt(1,pID) ;
          ResultSet arRs=pstmt.executeQuery() ;
          if(arRs.next()){
              sTopic=arRs.getString("topic");
              sBody=arRs.getString("body");
              sAuthor=arRs.getString("author");
              sCreateDate=arRs.getString("createdate");
              bLock=arRs.getBoolean("islock");

          }else{
              throw new ArticleNotFoundException("ID:"+pID+" article not found..");
          }
      }catch(SQLException e){
          Debug.println(e.toString()) ;

      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }

  }

 }