package org.softme.webpm.wiki;
import java.sql.*;
import org.softme.webpm.pub.*;
import org.softme.webpm.utility.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleManager {
  Connection conn=null;
  PreparedStatement pstmt=null;
  KeyIndex keyIndex=KeyIndex.getInstance() ;
  public ArticleManager() {
  }
  public Article newArticle(){
      return new Article();
  }
  public Article addArtilce(String pTopic,String pBody,String pAuthor){
      keyIndex.addKey(StringUtility.URLParamEncode(pTopic)) ;
      return new Article(pTopic,pBody,pAuthor);
  }
  public void revert(int pBackupID){
      try{
          ArticleBackup backup=new ArticleBackup(pBackupID);
          Article ar=getArticle(backup.getTopic());
          ar.setBody(backup.getBody()) ;
          ar.setAuthor(backup.getAuthor()) ;
          ar.setCreateDate(backup.getCreateDate());
          ar.setLock(backup.isLock()) ;
          ar.updateBody() ;//¸»Զһ

      }catch(Exception e){
          e.printStackTrace() ;
      }
  }
  public Article getArticle(String pTopic) throws ArticleNotFoundException{
      try{
          String GET_ONE_ARTICLE="SELECT * FROM webpm.article WHERE binary topic=?";
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_ONE_ARTICLE) ;
          //вѯʱȽб
          pTopic=StringUtility.encodeToMysql(pTopic) ;
          pstmt.setString(1,pTopic) ;
          ResultSet arRs=pstmt.executeQuery() ;
          if(arRs.next()){
              return new Article(arRs.getString("topic"),arRs.getString("body"),
                                 arRs.getString("author"),arRs.getString("createdate"),
                                 arRs.getBoolean("islock"));

          }else{
              throw new ArticleNotFoundException(pTopic+" article not found..");
          }
      }catch(SQLException e){
          Debug.println(e.toString()) ;
          return null;
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }

  }
  public void updateArticleBody(Article pArticle){
      pArticle.updateBody() ;
  }
  public void lock(String pTopic){
      changeLockStatus(pTopic,1);
  }
  public void unlock(String pTopic){
      changeLockStatus(pTopic,0);
  }
  private void changeLockStatus(String pTopic,int pStatus){
      String UPDATE_ARTICLE="UPDATE article SET islock=? WHERE binary topic=?";
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
          pstmt.setInt(1 ,pStatus) ;
          pstmt.setString(2,pTopic) ;
          pstmt.executeUpdate() ;
      }catch(SQLException e){
          Debug.println(e.toString() ) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn);
      }
  }


}