package org.softme.webpm.wiki;
import junit.framework.*;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.utility.StringUtility;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleManagerTest extends TestCase{

  public ArticleManagerTest(String name) {
      super(name);
  }
  public static void main(String args[]){
      junit.textui.TestRunner.run(ArticleManagerTest.class) ;
  }
  public void testNew(){
      String sTopic="test";
      String sBody="testbb\r\nBBB";
      String sAuthor="testa";
      ArticleManager arM=new ArticleManager();
      Article newAr=arM.addArtilce(StringUtility.encodeToMysql(sTopic),sBody,sAuthor);
      try{
          newAr=arM.getArticle(sTopic);
          assertEquals(sTopic,StringUtility.encodeToMysql(newAr.getTopic()));
          assertEquals(sBody,newAr.getBody());
          assertEquals(sAuthor,newAr.getAuthor());
          assert(null!=newAr.getCreateDate() );
          assertEquals(false,newAr.isLock() );
      }catch(ArticleNotFoundException e){
          Debug.println(e.toString() );
          assert(false);
      }
  }
  public void testUpdateBody(){
      try{
          ArticleManager arM=new ArticleManager();
          arM.addArtilce("test","testb","testa") ;
          Article ar=arM.getArticle("test") ;
          ar.setBody("testbb");
          arM.updateArticleBody(ar);
          ar=arM.getArticle("test") ;
          assertEquals(ar.getTopic() ,"test");


      }catch(ArticleNotFoundException e){
          Debug.println(e.toString()) ;
          assert(false);
      }
  }
  public void testLock(){
      ArticleManager arM=new ArticleManager();
      arM.lock("WebPm") ;
  }
  public void testRevert(){
      try{
      ArticleManager arM=new ArticleManager();
      arM.revert(83);
      Article ar=arM.getArticle("test") ;
      assertEquals(ar.getBody(),"testbb\r\nBBB");
      }catch(Exception e){
          assert(false);
      }
  }


}