package org.softme.webpm.wiki;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */


import java.io.*;
import java.util.*;
import org.apache.regexp.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.softme.webpm.pub.*;

public class TagProcessor {
    private static final String XML_CONFIG_FILE = "c:\\TAG.xml";
    //private static final String XML_CONFIG_FILE = "/usr/tomcat/tomcat/webapps/webpm/TAG.xml";
    private static Document doc = null;
    private static TagProcessor tagProcessorInstance=null;
    private static org.apache.xerces.parsers.DOMParser parser =
        new org.apache.xerces.parsers.DOMParser();

    private static Vector customTags=null;
    private static Vector autoLinkTags=null;
    private static Vector htmlTags=null;
    private static Tag autoLinkNotFoundTag=null;

    private TagProcessor() {
        loadTags();
    }
    /**
     * ֻ֤һʵ
     */
    public static TagProcessor getInstance(){
        if(tagProcessorInstance==null){

            tagProcessorInstance=new TagProcessor();

        }
        return tagProcessorInstance;
    }

    public  String parse(String inStr){
        Tag customTag,FoundTag,htmlTag;

        try{
            for(int k=0;k<htmlTags.size() ;k++){
                Debug.print(Integer.toString(htmlTags.size()));
                htmlTag=(Tag)htmlTags.elementAt(k) ;
                inStr=REReplace.replace(htmlTag.getCustomTag(),htmlTag.getHtmlTag(),inStr) ;
                Debug.println(htmlTag.getCustomTag()+"---"+htmlTag.getHtmlTag() ) ;
            }
            for(int i=0;i<customTags.size() ;i++){
                customTag=(Tag)customTags.elementAt(i)  ;
                inStr=REReplace.replace(customTag.getCustomTag(),customTag.getHtmlTag(),inStr) ;
                //Debug.println(customTag.getCustomTag()+"---"+customTag.getHtmlTag() ) ;
            }
           // Debug.println(inStr) ;

           for(int j=0;j<autoLinkTags.size() ;j++){
                FoundTag=(Tag)autoLinkTags.elementAt(j) ;
                inStr=REReplace.replaceAutoLink(FoundTag.getCustomTag(),FoundTag.getHtmlTag(),
                                          autoLinkNotFoundTag.getHtmlTag(),inStr) ;
                //Debug.println(FoundTag.getCustomTag()+"---"+FoundTag.getHtmlTag() ) ;
            }
            //Debug.println(inStr) ;
        }catch(Exception err){
            err.printStackTrace() ;
            Debug.println(err.toString());

        }
        return inStr;
    }


    /**
     * parse the xml file to Document object
    **/

    private Document xml2Document(){
        try{
            //InputStream is = Thread.currentThread().getContextClassLoader()
            //                .getResourceAsStream(XML_CONFIG_FILE);
            parser.parse(XML_CONFIG_FILE) ;
            Document document =parser.getDocument();
            return document;
        }catch(Exception err){
            System.out.println(err);
            return null;
        }
    }

    private void loadTags(){
        try{
            Debug.print("TagProcessor init....") ;
            Document document=xml2Document();
            Element rootElement=document.getDocumentElement() ;
            customTags=loadCustomTag(rootElement);
            autoLinkTags=loadAutoLinkFoundTags(rootElement);
            autoLinkNotFoundTag=loadAtuoLinkNotFoundTags(rootElement);
            htmlTags=loadHtmlTag(rootElement);
            Debug.println("Succeed!") ;
        }catch(Exception e){
            Debug.println("False!") ;
            Debug.println(e.toString()) ;
        }
    }
    /**
     * mapڵ,õǩͱǩӦ滻ַ
     * @param pNodeList ڵб
     * @param pTags Ǽ
     */
    private void processTagNode(NodeList pNodeList,Vector pTags){
        Node node;
        Tag newTag;
        int tagNumber=pNodeList.getLength() ;
        for(int i=0;i<tagNumber;i++){
            node=pNodeList.item(i) ;
            NamedNodeMap attributes=node.getAttributes() ;
            //Debug.println((attributes.item(1)).getNodeValue() ) ;
            //Debug.println((attributes.item(0)).getNodeValue() ) ;

            newTag=new Tag();
            newTag.setCustomTag(attributes.item(1).getNodeValue()) ;
            newTag.setHtmlTag(attributes.item(0).getNodeValue());
            pTags.addElement(newTag) ;

        }
    }
    /**
     * @param currentElement ҵĽڵ
     * @param parentNodeName ڵ
     * @param childNodeName ӽڵ
     * currentElementڵ,ݸڵƵõӽڵб
     */
    private  NodeList findChildren(Element currentElement,String parentNodeName,String childNodeName){
        try{
            NodeList customTag=currentElement.getElementsByTagName(parentNodeName) ;
            Element mapE=(Element)customTag.item(0) ;
            NodeList children=mapE.getElementsByTagName(childNodeName)  ;
            return children;

        }catch(Exception err){
            err.printStackTrace() ;
            Debug.println(err.toString()) ;
            return null;
        }
    }
    /**
     * Զǩ
     */
    private Vector loadCustomTag(Element customTagElement){
        Vector customVector=new Vector();
        try{
            NodeList children=findChildren(customTagElement,"custom-tag","map");
            processTagNode(children,customVector);
        }catch(Exception err){
            err.printStackTrace() ;
            Debug.println(err.toString()) ;
        }
        return customVector;

    }
    private Vector loadHtmlTag(Element htmlTagElement){
        Vector htmlVector=new Vector();
        try{
            NodeList children=findChildren(htmlTagElement,"html-tag","map");
            processTagNode(children,htmlVector);
        }catch(Exception err){
            err.printStackTrace() ;
            Debug.println(err.toString()) ;
        }
        return htmlVector;

    }
    /**
     * Զӱǩ
     */
    private Vector loadAutoLinkFoundTags(Element pAutoLinkTag){
        Vector autoLinkFoundVector=new Vector();
        try{
            NodeList children=findChildren(pAutoLinkTag,"topicfound-tag","map");
            processTagNode(children,autoLinkFoundVector);
        }catch(Exception e){
            Debug.println(e.toString());
        }
        return autoLinkFoundVector;
    }

    private Tag loadAtuoLinkNotFoundTags(Element pAutoLinkTag){
        Vector autoLinkNotFoundVector=new Vector();

        try{
            NodeList children=findChildren(pAutoLinkTag,"topicnotfound-tag","map");
            processTagNode(children,autoLinkNotFoundVector);
        }catch(Exception e){
            Debug.println(e.toString());
        }
       // return new Tag();
        return (Tag)autoLinkNotFoundVector.elementAt(0) ;
    }

    public static void main(String args[]){
        String testString="testStringAtFirst";
        int b=testString.indexOf("at")+"at".length() ;
        String bs=testString.substring(0,b) ;
        String be=testString.substring(b,testString.length()) ;
        System.out.println("bs:"+bs+"|be:"+be) ;
        System.out.print(testString.indexOf("kk")) ;
    }


}

