package org.softme.webpm.wiki;
import junit.framework.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class TagProcessorTest extends TestCase{

  public TagProcessorTest(String name) {
    super(name);
  }
  public void testParse(){
      TagProcessor pmTag=TagProcessor.getInstance();
      String testI="[i]I[/i]";
      String resultI="<i>I</i>";
      String testURL="[url target=HREF]URL[/url]";
      String resultURL="<a href=\"HREF\" target=_blank>URL</a>";
      String testH1="[h1]H1[/h1]";
      String resultH1="<h1>H1</h1>";
      String testEMAIL="[email=HREF]MAILTO[/email]";
      String resultEMAIL="<a href=\"mailto:HREF\">MAILTO</a>";
      String testIMG="[img]IMG[/img]";
      String resultIMG="<img src=\"IMG\"  border=0>";
      String testCODE="[code]code[/code]";
      String resultCODE="<br><hr><BLOCKQUOTE>CODE</BLOCKQUOTE><hr><br>";
      String testPRE="[pre]PRE[/pre]";
      String resultPRE="<pre>PRE</pre>";
      String testHR="[hr]";
      String resultHR="<br><hr><br>";
      String testFound="[Topic]";
      String resultFound="<a href=\"http://localhost:8080/webpm/jwiki/jwiki.jsp?topic=Topic\">Topic</a>";
      String testNotFound="[TopicNotFound]";
      String resultNotFound="TopicNotFound<a href=\"http://localhost:8080/webpm/jwiki/jwiki.jsp?topic=TopicNotFound\">?</a>";
      String testEnglish="TestEnglish yyy";
      String resultEnglish="<a href=\"http://localhost:8080/webpm/jwiki/jwiki.jsp?topic=TestEnglish\">TestEnglish</a> ";
      String testHttp="http://www.16885.com";
      String resultHttp="<a href='http://www.sina.com.cn/index.jsp?param=value&param2=values'>www.sina.com.cn/index.jsp?param=value&param2=values</a>";


      testEnglish=pmTag.parse(testEnglish) ;
      testHttp=pmTag.parse(testHttp) ;
      testURL=pmTag.parse(testURL);
      testI=pmTag.parse(testI);
      testH1=pmTag.parse(testH1);
      testPRE=pmTag.parse(testPRE);
      testCODE=pmTag.parse(testCODE);
      testIMG=pmTag.parse(testIMG);
      testEMAIL=pmTag.parse(testEMAIL);
      testHR=pmTag.parse(testHR);
      testFound=pmTag.parse(testFound) ;
      testNotFound=pmTag.parse(testNotFound) ;

      //assertEquals(testHttp,resultHttp);
      assertEquals(testEnglish,resultEnglish);
      assertEquals(testI,resultI);
      assertEquals(testURL,resultURL);
      assertEquals(testH1,resultH1);
      assertEquals(testEMAIL,resultEMAIL);
      assertEquals(testIMG,resultIMG);
      assertEquals(testCODE,resultCODE);
      assertEquals(testPRE,resultPRE);
      assertEquals(testHR,resultHR);
      assertEquals(testFound,resultFound);
      assertEquals(testNotFound,resultNotFound);
  }
  public static void main(String[] args) {
    junit.textui.TestRunner.run(TagProcessorTest.class) ;
  }
}