package org.softme.webpm.wiki;
import java.util.Iterator;
import java.util.Vector;
import java.sql.*;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.*;
import org.softme.webpm.utility.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WikiSearcher {
private String sKey=null;
  public WikiSearcher(String pKey) {
      sKey=pKey;
  }
  public Iterator searchBody(){
      final String SEARCH_FROM_BODY="SELECT * FROM article WHERE body like ?";
      return search(SEARCH_FROM_BODY);

  }
  public Iterator searchTopic(){
      final String SEARCH_FROM_TOPIC="SELECT * FROM article WHERE topic like ?";
      return search(SEARCH_FROM_TOPIC);
  }
  private Iterator search(String pSql){
      Vector searchResult=new Vector();
      Connection conn=null;
      PreparedStatement pstmt=null;
      String sTopic=null;
      Article article=null;
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(pSql) ;
          pstmt.setString(1,"%"+sKey+"%") ;
          Debug.print(sKey) ;
          ResultSet arRs=pstmt.executeQuery() ;
          while(arRs.next()){
              article=new Article(arRs.getString("topic"),arRs.getString("body"),
                                  arRs.getString("author"),arRs.getString("createdate"),
                                  arRs.getBoolean("islock"));
              searchResult.addElement(article) ;
          }
      }catch(Exception e){
          e.printStackTrace() ;
          Debug.println(e.toString()) ;
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }
      return searchResult.iterator() ;

  }



}