package org.softme.webpm.jwiki;
import org.softme.webpm.pub.*;
import org.softme.webpm.utility.*;
import java.sql.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleImp implements Article{
    protected String gTopic,gBody,gCreateDate,gAuthor,gMender;
    protected int gFlag,gID;

    public int getID(){
        return gID;
    }
    public String getTopic(){
        return gTopic;
    }
    public String getBody(){
        return gBody;
    }
    public String getAuthor(){
        return gAuthor;
    }
    public String getCreateDate(){
      return gCreateDate;
    }
    public String getMender(){
        return gMender;
    }
    public int getFlag(){
        return gFlag;
    }
    public void setID(int pID){
        this.gID =pID;
    }
    public void setBody(String aBody){
        this.gBody =aBody;
    }
    public void setTopic(String aTopic){
        this.gTopic =aTopic;
    }
    public void setAuthor(String aAuthor){
        this.gAuthor =aAuthor;
    }
    public void setMender(String aMender){
        this.gMender =aMender;
    }
    public void setFlag(int aFlag){
        this.gFlag =aFlag;
    }
    public void setCreateDate(String aDate){
        this.gCreateDate =aDate;
    }
    public ArticleImp(String pTopic){
    }
    public ArticleImp(){
    }

    public ArticleImp(String pTopic,String pBody,String pAuthor){
        this.gTopic =pTopic;
        this.gAuthor =pAuthor;
        this.gMender =pAuthor;
        this.gBody =pBody;
        this.gCreateDate =DateTimeUtility.getCurrentDateTime() ;
        this.gFlag =Article.UNLOCK;
        insertToDB();
    }
    public String getWikiBody(){

       TagProcessorFactory tagFactory=TagProcessorFactory.getInstance() ;

       return tagFactory.processTags(gBody) ;
    }

    public Article modifyBody(){
        ModifyBodyToDB();
        return this;
    }

    public void updateAllInfo(){

        String UPDATE_ARTICLE="UPDATE t_wiki_article SET fbody=?,fmender=?,fcreatedate=?,fauthor=?,fflag=? WHERE ftopic=?";
        gCreateDate=DateTimeUtility.getCurrentDateTime();
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
            pstmt.setString(1,StringUtility.encodeMenory2DB(gBody)) ;
            pstmt.setString(2,StringUtility.encodeMenory2DB(gMender)) ;
            pstmt.setString(3,gCreateDate) ;
            pstmt.setString(4,StringUtility.encodeMenory2DB(gAuthor)) ;
            pstmt.setInt(5,gFlag) ;
            pstmt.setString(6,StringUtility.encodeMenory2DB(gTopic)) ;
            pstmt.executeUpdate() ;
            insertBackup(conn);
        }catch(SQLException e){
            Debug.println(e.toString() ) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    public void changeFlag(int pFlag){
        gFlag=pFlag;
        modifyFlag();

    }
    private void modifyFlag(){
        String UPDATE_ARTICLE="UPDATE t_wiki_article SET fflag=? WHERE ftopic=?";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
            pstmt.setInt(1 ,gFlag) ;
            pstmt.setString(2,StringUtility.encodeMenory2DB(gTopic)) ;
            pstmt.executeUpdate() ;
        }catch(SQLException e){
            Debug.println(e.toString() ) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    private void ModifyBodyToDB(){
        String UPDATE_ARTICLE="UPDATE t_wiki_article SET fbody=?,fmender=?,fcreatedate=? WHERE ftopic=?";
        gCreateDate=DateTimeUtility.getCurrentDateTime();
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
            pstmt.setString(1,StringUtility.encodeMenory2DB(gBody)) ;
            pstmt.setString(2,StringUtility.encodeMenory2DB(gMender)) ;
            pstmt.setString(3,gCreateDate) ;
            pstmt.setString(4,StringUtility.encodeMenory2DB(gTopic)) ;
            pstmt.executeUpdate() ;
            insertBackup(conn);
        }catch(SQLException e){
            Debug.println(e.toString() ) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    private void insertToDB(){
        String INSERT_ARTICLE="INSERT INTO t_wiki_article (ftopic,fbody,fauthor,fmender,fcreatedate,fflag) values (?,?,?,?,?,?) ";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(INSERT_ARTICLE) ;
            pstmt.setString(1,StringUtility.encodeMenory2DB(gTopic)) ;
            pstmt.setString(2,StringUtility.encodeMenory2DB(gBody));
            pstmt.setString(3,StringUtility.encodeMenory2DB(gAuthor)) ;
            pstmt.setString(4,StringUtility.encodeMenory2DB(gMender));
            pstmt.setString(5,gCreateDate) ;
            pstmt.setInt(6,gFlag) ;
            pstmt.executeUpdate() ;
            //ݲ,conn Ϊ֧
            insertBackup(conn);
        }catch(SQLException e){
            Debug.println(e.toString()) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    private void insertBackup(Connection conn){
        String INSERT_ARTICLE_BACKUP="INSERT INTO t_wiki_articlebackup(ftopic,fbody,fauthor,fmender,fcreatedate,fflag) values (?,?,?,?,?,?)";
        PreparedStatement pstmt=null;
        try{
            pstmt=conn.prepareStatement(INSERT_ARTICLE_BACKUP) ;
            pstmt.setString(1,StringUtility.encodeMenory2DB(gTopic) ) ;
            pstmt.setString(2,StringUtility.encodeMenory2DB(gBody) );
            pstmt.setString(3,StringUtility.encodeMenory2DB(gAuthor)) ;
            pstmt.setString(4,StringUtility.encodeMenory2DB(gMender));
            pstmt.setString(5,gCreateDate) ;
            pstmt.setInt(6,gFlag) ;
            pstmt.executeUpdate() ;
        }catch(SQLException e){
            e.printStackTrace() ;
        }finally{
            try{
                pstmt.close() ;
            }catch(SQLException e){
                e.printStackTrace() ;
            }
        }
  }
}