package org.softme.webpm.pub ;
import org.softme.webpm.utility.XMLUtility;
import java.io.*;
import java.util.*;
import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import java.io.File;
import java.net.URL;
import java.net.MalformedURLException;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class WebPmConfig {

    static private WebPmConfig configInstance=null;
    static private HashMap properties=new HashMap();
    static public String SEPARATOR=(System.getProperties()).getProperty("file.separator");

    private WebPmConfig() {

    }
    public static String getProperty(String pParam){
        if(configInstance==null){
            configInstance=new WebPmConfig();
            Debug.println("Config properties....") ;
            configInstance.loadFilePath() ;
            configInstance.loadProperties();
        }
        String value=(String)properties.get(pParam) ;
        return value;

    }


    private static void loadProperties(){


        //Debug.println(WebPmConfig.getProperty("Path.configfile")+"##########");
        ///usr/tomcat/tomcat/webapps/webpm/conf/config.xml

        Document doc=XMLUtility.xml2Document(WebPmConfig.getProperty("Path.configfile")) ;
        Element rootElement=doc.getDocumentElement() ;
        Element jwikiElement=(Element)(rootElement.getElementsByTagName("Jwiki").item(0)) ;
        Element encoderElement=(Element)(rootElement.getElementsByTagName("Encoder").item(0));
        loadChineseCode(encoderElement);
        loadDBConfig(rootElement);
        loadWikiConfig(jwikiElement);
        Debug.print("\n") ;
    }

    private static void loadFilePath(){
        String pmHome = null;
        ClassLoader systemClassLoader =WebPmConfig.class.getClassLoader();
        if (systemClassLoader == null) {
           // antHome = determineAntHome11();
           System.out.println("ClassLoader error") ;
        }
        else {
            pmHome = determineWebPMHome(systemClassLoader);
        }
        if (pmHome == null) {
            System.err.println("Unable to determine WebPM_HOME");
            System.exit(1);
        }
       Debug.println("WebPM_HOME:"+pmHome) ;
       properties.put("WebPM.Home",pmHome) ;///usr/tomcat/tomcat/webapps/webpm

       String tagFile=WebPmConfig.getProperty("WebPM.Home")+"conf"+WebPmConfig.SEPARATOR+"tag.xml";
       String configFile=WebPmConfig.getProperty("WebPM.Home")+"conf"+WebPmConfig.SEPARATOR+"config.xml";


       properties.put("Path.tagfile",tagFile) ;
       properties.put("Path.configfile",configFile) ;

       Debug.println("tag file path: "+tagFile) ;
       Debug.println("config file path: "+configFile) ;
    }

    private static void loadWikiConfig(Element rootElement){
        String articleFactoryClassName=XMLUtility.getNodeAttr(rootElement,"ArticleFactoryImp","className") ;
        String tagProcessorFactoryClassName=XMLUtility.getNodeAttr(rootElement,"TagProcessorFactoryImp","className") ;
        properties.put("ArticleFactoryImp.className",articleFactoryClassName) ;
        properties.put("TagProcessorFactoryImp.className",tagProcessorFactoryClassName) ;

        Debug.println("ArticleFactoryImp.className: "+articleFactoryClassName) ;
        Debug.println("TagProcessorFactoryImp.className: "+tagProcessorFactoryClassName) ;
    }
    private static void loadChineseCode(Element rootElement){
        String urlParam2StringCode=XMLUtility.getNodeAttr(rootElement,"URLParam2String","Code");
        String urlParam2StringGetBytesCode=XMLUtility.getNodeAttr(rootElement,"URLParam2String","GetBytes");

        String string2URLParamCode=XMLUtility.getNodeAttr(rootElement,"String2URLParam","Code") ;
        String string2URLParamGetBytesCode=XMLUtility.getNodeAttr(rootElement,"String2URLParam","GetBytes");

        String menory2DBCode=XMLUtility.getNodeAttr(rootElement,"Menory2DB","Code");
        String menory2DBGetBytesCode=XMLUtility.getNodeAttr(rootElement,"Menory2DB","GetBytes");

        String db2MenoryCode=XMLUtility.getNodeAttr(rootElement,"DB2Menory","Code") ;
        String db2MenoryGetBytesCode=XMLUtility.getNodeAttr(rootElement,"DB2Menory","GetBytes");

        properties.put("Encoder.String2URLParamCode",string2URLParamCode) ;
        properties.put("Encoder.String2URLParamGetBytesCode",string2URLParamGetBytesCode) ;

        properties.put("Encoder.URLParam2StringCode",urlParam2StringCode);
        properties.put("Encoder.URLParam2StringGetBytesCode" ,urlParam2StringGetBytesCode);

        properties.put("Encoder.Menory2DBCode" ,menory2DBCode);
        properties.put("Encoder.Menory2DBGetBytesCode" ,menory2DBGetBytesCode);

        properties.put("Encoder.DB2MenoryCode",db2MenoryCode) ;
        properties.put("Encoder.DB2MenoryGetBytesCode",db2MenoryGetBytesCode) ;
        /////////////////////////////////////////////
        Debug.println("Encoder.DB2MenoryCode:"+(String)properties.get("Encoder.DB2MenoryCode")) ;
        Debug.println("Encoder.DB2MenoryGetBytesCode:"+(String)properties.get("Encoder.DB2MenoryGetBytesCode")) ;

        Debug.println("Encoder.Menory2DBCode:"+(String)properties.get("Encoder.Menory2DBCode")) ;
        Debug.println("Encoder.Menory2DBGetBytesCode:"+(String)properties.get("Encoder.Menory2DBGetBytesCode")) ;

        Debug.println("Encoder.URLParam2StringCode:"+(String)properties.get("Encoder.URLParam2StringCode")) ;
        Debug.println("Encoder.URLParam2StringGetBytesCode:"+(String)properties.get("Encoder.URLParam2StringGetBytesCode"))  ;

        Debug.println("Encoder.String2URLParamCode:"+(String)properties.get("Encoder.String2URLParamCode")) ;
        Debug.println("Encoder.String2URLParamGetBytesCode:"+(String)properties.get("Encoder.String2URLParamGetBytesCode")) ;


       // Debug.println("Chinese Encode:StringCode is:"+StringCode+"    GetBytes is:"+StringGetBytesCode) ;

        //Debug.println("DB Encode:StringCode is:"+DBCode+"    GetBytes is:"+DBGetBytesCode) ;
    }
    private static void loadDBConfig(Element rootElement){
        String DBUserName=XMLUtility.getNodeAttr(rootElement,"DBConfig","UserName");
        String DBURL=XMLUtility.getNodeAttr(rootElement,"DBConfig","URL");
        String DBPassword=XMLUtility.getNodeAttr(rootElement,"DBConfig","Password");
        String DBDriver=XMLUtility.getNodeAttr(rootElement,"DBConfig","Driver");

        properties.put("DB.UserName" ,DBUserName);
        properties.put("DB.URL" ,DBURL);
        properties.put("DB.Password" ,DBPassword);
        properties.put("DB.Driver" ,DBDriver) ;

        Debug.println("DB Driver :"+DBDriver);
        Debug.println("DB URL:"+DBURL);


    }
    static private String determineWebPMHome(ClassLoader systemClassLoader) {
        String className =WebPmConfig.class.getName().replace('.', '/') + ".class";
        URL classResource = systemClassLoader.getResource(className);
        String fileComponent = classResource.getFile();

        File webPMDir=new File(fileComponent);
        String dirName=webPMDir.toString();
        Debug.println(webPMDir.toString()) ;
        String webPMHome=dirName.substring(0,dirName.indexOf("WEB-INF"));
        return webPMHome;

    }


}