package org.softme.webpm.test;
import java.net.URL;
import java.net.MalformedURLException;
import java.io.*;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class TestPath {

    public TestPath() {
    }
    static private File determineAntHome(ClassLoader systemClassLoader) {
        try {
            String className =TestPath.class.getName().replace('.', '/') + ".class";
            URL classResource = systemClassLoader.getResource(className);
            String fileComponent = classResource.getFile();
            if (classResource.getProtocol().equals("file")) {
                // Class comes from a directory of class files rather than
                // from a jar.
                int classFileIndex = fileComponent.lastIndexOf(className);
                if (classFileIndex != -1) {
                    fileComponent = fileComponent.substring(0, classFileIndex);
                }
                File classFilesDir = new File(fileComponent);
                System.out.println(classFilesDir) ;
                File buildDir = new File(classFilesDir.getParent());
                 System.out.println(buildDir) ;
                File devAntHome = new File(buildDir.getParent());
                 System.out.println(devAntHome) ;
                return devAntHome;
            }
            else if (classResource.getProtocol().equals("jar")) {
                // Class is coming from a jar. The file component of the URL
                // is actually the URL of the jar file
                int classSeparatorIndex = fileComponent.lastIndexOf("!");
                if (classSeparatorIndex != -1) {
                    fileComponent = fileComponent.substring(0, classSeparatorIndex);
                }
                URL antJarURL = new URL(fileComponent);
                System.out.println(antJarURL) ;
                File antJarFile = new File(antJarURL.getFile());
                System.out.println(antJarFile) ;
                File libDirectory = new File(antJarFile.getParent());
                System.out.println(libDirectory) ;
                File antHome = new File(libDirectory.getParent());
                System.out.println(antHome) ;
                return antHome;
            }
        }
        catch (MalformedURLException e) {
            e.printStackTrace();
        }
        return null;
    }
    public static void main(String args[]){
        File antHome = null;
        ClassLoader systemClassLoader =TestPath.class.getClassLoader();
        if (systemClassLoader == null) {
           // antHome = determineAntHome11();
           System.out.println("Erorr") ;
        }
        else {
            antHome = determineAntHome(systemClassLoader);
        }
        if (antHome == null) {
            System.err.println("Unable to determine ANT_HOME");
            System.exit(1);
        }

        System.out.println("ANT_HOME is " + antHome);
    }
}