package org.softme.webpm.jwiki;
import org.softme.webpm.pub.Debug;
import java.util.Iterator;
import org.softme.webpm.pub.WebPmConfig;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public abstract class ArticleFactory {
    private static Object initLock = new Object();
    private static String className = "org.softme.webpm.jwiki.ArticleFactoryImp";
    private static ArticleFactory arFactory = null;

    public static ArticleFactory getInstance(){
        if (arFactory == null) {
            synchronized(initLock) {
                if (arFactory == null) {
                    try {
                        String classNameProp=WebPmConfig.getProperty("ArticleFactoryImp.className");
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);
                        arFactory = (ArticleFactory)c.newInstance();
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load ArticleFactory class "
                            + className + ". Jwiki cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return arFactory;

    }


    public abstract Article createArticle(String pTopic,String pBody,String pAuthor) throws ArticleAlreadyExistsException;

    /**
     * һյArticle
     */
    public abstract Article newArticle();
    /**
     * õ
     */
    public abstract Article getArticle(int pID) throws ArticleNotFoundException;

    public abstract Article getArticle(String pTopic) throws ArticleNotFoundException;

    public abstract Article getBackup(int pID) throws ArticleNotFoundException;
    /**
     * µб
     */
    public abstract Iterator getRecentChanges();

    /**
     * ñݿеһƪ¸
     * param pBackupID  ݿµIDš
     */
    public abstract Article revert(int pBackupID);

    /**
     * һѯ
     * param pKey ѯ
     */
    public abstract Query createQuery(String pKey);

    /**
     * õһİ汾
     */
    public abstract Iterator getVersions(String pTopic);




}