package org.softme.webpm.jwiki;
import junit.framework.*;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleTest extends TestCase{
  private  ArticleFactory arFactory=ArticleFactory.getInstance() ;
  public ArticleTest(String name) {
      super(name);
  }
  public static void main(String[] args) {
      //junit.framework.TestSuite articleTest=new TestSuite(ArticleTest.class);
      junit.textui.TestRunner.run(ArticleTest.class) ;
  }
  public static TestSuite suite(){
      return new TestSuite(ArticleTest.class);
  }
  public void testModify(){
      try{
          String mTopic="testtopic";
          String mNewBody="newBody";
          String mMender="climber";
          Article existingAr=arFactory.getArticle(mTopic);
          existingAr.setBody(mNewBody);
          existingAr.setMender(mMender);
          existingAr.modifyBody();
          existingAr=arFactory.getArticle(mTopic);
          assertEquals(existingAr.getTopic(),mTopic);
          assertEquals(existingAr.getBody(),mNewBody);
          assertEquals(existingAr.getMender(),mMender);
      }catch(Exception e){
          System.out.print(e.toString() ) ;
          assert(false);
      }
  }
  public void testLock(){
      try{
          String mWillLockTopic="testtopic";
          Article existingAr=arFactory.getArticle(mWillLockTopic);
          existingAr.changeFlag(Article.LOCK);
          existingAr=arFactory.getArticle(mWillLockTopic);
          assertEquals(existingAr.getFlag(),Article.LOCK);
      }catch(ArticleNotFoundException e){
          assert(false);
      }

  }

  public void testUnLock(){
      try{
          String mWillUnLockTopic="testtopic";
          Article existingAr=arFactory.getArticle(mWillUnLockTopic);
          existingAr.changeFlag(Article.UNLOCK ) ;
          existingAr=arFactory.getArticle(mWillUnLockTopic);
          assertEquals(existingAr.getFlag() ,Article.UNLOCK);
      }catch(Exception e){
          assert(false);
      }

  }
}