package org.softme.webpm.servlet;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import org.softme.webpm.jwiki.*;
import org.softme.webpm.utility.StringUtility;
import org.softme.webpm.pub.Debug;
import java.net.URLEncoder;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class JwikiCortrol extends HttpServlet {
  private static final String CONTENT_TYPE = "text/html; charset=GB2312";
  /**Initialize global variables*/
  public void init() throws ServletException {
  }
  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

      doPost(request,response);
  }
  public void doPost(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException {
      response.setContentType(CONTENT_TYPE);
      PrintWriter out = response.getWriter();
      HttpSession session=request.getSession() ;
      String action=request.getParameter("action") ;
      ArticleFactory arFactory=ArticleFactory.getInstance();
      String sTopic=request.getParameter("topic").trim();
      String sBody=request.getParameter("body");
      String sAuthor=request.getParameter("author") ;
      String sMender=request.getParameter("mender") ;
      out.println(sTopic) ;
      //sTopic=new String(sTopic.getBytes("ISO-8859-1"),"GB2312");
      sTopic=StringUtility.encodeURLParam2String(sTopic) ;
      sBody=StringUtility.encodeURLParam2String(sBody) ;
      sMender=StringUtility.encodeURLParam2String(sMender);
      sAuthor=StringUtility.encodeURLParam2String(sAuthor) ;

      out.println(sTopic) ;
     // if(true) return;
      if(sAuthor==null||sAuthor.equals("")||sAuthor.equals("null")){
          sAuthor=request.getRemoteAddr() ;//request.getParameter("author");
      }
      if(sMender==null||sMender.equals("")||sMender.equals("null")){
          sMender=request.getRemoteAddr();
      }


      if(action.equalsIgnoreCase("add")){
          try{
              arFactory.createArticle(sTopic ,sBody ,sAuthor) ;
              sTopic=StringUtility.encodeString2URLParam(sTopic) ;
              response.sendRedirect("/webpm/jwiki/jwiki.jsp?topic="+sTopic) ;
          }catch(ArticleAlreadyExistsException ex){
              Debug.println(ex.toString());
              ex.printStackTrace() ;
          }
      }
      if(action.equalsIgnoreCase("save") ){

          try{


              Article ar=arFactory.getArticle(sTopic) ;
              //out.print(sTopic+"**");
              ar.setAuthor(ar.getAuthor()) ;
              ar.setBody(sBody) ;
              ar.setMender(sMender) ;
              ar.modifyBody();
              sTopic=StringUtility.encodeString2URLParam(sTopic) ;
              response.sendRedirect("/webpm/jwiki/jwiki.jsp?topic="+sTopic) ;
          }catch(ArticleNotFoundException e){
              out.print(e.toString() ) ;
          }
      }
      if(action.equalsIgnoreCase("revert") ){
          int iID=Integer.parseInt(request.getParameter("id")) ;
          try{
              arFactory.getArticle(iID) ;
              arFactory.revert(iID) ;
              response.sendRedirect("/webpm/jwiki/version_manage.jsp") ;
          }catch(ArticleNotFoundException e){
              e.printStackTrace() ;
              out.print(e.toString() ) ;
          }

      }
      if(action.equalsIgnoreCase("lock")||action.equalsIgnoreCase("unlock") ){
          try{
              Article existingAr=arFactory.getArticle(sTopic) ;
              if(action.equalsIgnoreCase("lock")){
                  //arFactory.;
                  existingAr.changeFlag(Article.LOCK );
                  session.setAttribute("msg",sTopic+"  Ѿ") ;
              }
              if(action.equalsIgnoreCase("unlock")){
                 // arM.unlock(sTopic) ;
                  existingAr.changeFlag(Article.UNLOCK);
                  session.setAttribute("msg",sTopic+"  Ѿ") ;
              }

          }catch(ArticleNotFoundException e){
              out.print(e.toString()) ;
              session.setAttribute("msg",e.toString());

          }
          response.sendRedirect("/webpm/jwiki/admin/manage.jsp") ;
      }



  }
  /**Clean up resources*/
  public void destroy() {
  }
}